controllers/commons_resource.py
import services.homeless_service as homeless_service
import services.disappeared_service as disappeared_service
from flask import Blueprint, render_template, redirect, url_for

commons_controller = Blueprint("commons_controller", __name__)


@commons_controller.route("/faq")
def faq():
    return render_template("user/faq.html", title="FAQ", name="faq")


@commons_controller.route("/terms")
def terms():
    return render_template("user/terms.html")


@commons_controller.route("/info")
def info():
    result = dict()
    result["homeless"] = homeless_service.homeless_info().json()["homeless"]
    result["disappeared"] = disappeared_service.disappeared_info().json()["disappeared"]
    return render_template("info.html", title="Em tempo real", result=result, name="info")


@commons_controller.route("/start")
def start():
    return render_template("start_user.html", title="Cadastre-se", name="register")


@commons_controller.route("/")
def index():
    return redirect(url_for('missing_controller.index', page=0))

controllers/user_resource.py
from flask import Blueprint, abort, redirect, url_for, render_template, request, session, jsonify, flash
from werkzeug.exceptions import BadRequestKeyError

import parser.user_parse as user_parse
import services.disappeared_service as disappeared_service
import services.sighted_service as sighted_service
import services.user_service as user_service
from configuration.loggin_configuration import logger

user_controller = Blueprint('user_controller', __name__)


@user_controller.route("/create", methods=['GET'])
def create():
    return render_template("user/create.html", title="Cadastre-se", name="register")


@user_controller.route("<_id>/password", methods=["GET"])
def password(_id):
    if 'user' in session and session['user']['_id'] == _id:
        return render_template("user/password.html", title="Alterar senha", _id=_id)

    abort(403)


@user_controller.route("<_id>/change_password", methods=["POST"])
def change_password(_id):
    if 'user' in session and session['user']['_id'] == _id:
        result = user_service.update_password(_id, request.form.get("password"))
        if result.status_code == 200:
            flash("Senha alterada com sucesso!")
            return render_template("user/password.html", title="Alterar senha", _id=_id)

        abort(result.status_code)

    abort(403)


@user_controller.route("/register", methods=['POST'])
def create_user():
    try:
        parse = user_parse.user_json(request)

        result = user_service.create_user(parse)

        if result.status_code in [200, 201]:
            _id = result.json()["user"]["_id"]
            flash("Usuário criado com sucesso!")
            return redirect(url_for('missing_controller.create', _id=_id))

        abort(result.status_code)

    except BadRequestKeyError:
        return render_template("error/image_format.html")


@user_controller.route("/login", methods=["GET"])
def login():
    return render_template("user/login.html")


@user_controller.route("/authentication", methods=["POST"])
def authentication():
    try:
        auth = user_parse.authorization_json(request)

        user = user_service.authentication(auth)

        if user.status_code == 200:
            user_result = user.json()["user"]
            flash("Bem vindo {}".format(user_result["name"]))
            session["user"] = user_result
            return redirect(url_for('missing_controller.index', page=0))

        abort(user.status_code)

    except Exception as e:
        logger.error("Error during create homeless", e)
        abort(500)


@user_controller.route("/logout", methods=["GET"])
def logout():
    session.pop('user', None)
    return redirect(url_for('missing_controller.index', page=0))


@user_controller.route("/terms/<_id>", methods=['GET'])
def terms(_id):
    return render_template("user/terms.html", _id=_id)


@user_controller.route('/notifications/<_id>', methods=['GET'])
def notifications(_id):
    if 'user' in session and session['user']['_id'] == _id:
        return render_template("user/notifications.html",
                               title="Locais onde foi avistado",
                               _id=_id)

    abort(403)


@user_controller.route('/notifications-list/<_id>', methods=['GET'])
def notifications_list(_id):
    if 'user' in session and session['user']['_id'] == _id:
        disappeared = disappeared_service.get_by_user_id(_id)
        sighted = []
        if disappeared.status_code == 200:
            for missing in disappeared.json()["disappeared"]:
                for sighted_list in sighted_service.find_by_missing(missing["_id"]).json()["sighted"]:
                    sighted.append(sighted_list)

        return jsonify({'locations': sighted})


@user_controller.route("/remember-me", methods=['GET'])
def remember_me():
    return render_template("remember.html")


@user_controller.route('/remember', methods=['POST'])
def remember():
    try:
        result = user_service.remember_password(user_parse.remember_password(request))

        if result.status_code == 200:
            flash("Senha recuperada com sucesso, verifique sua nova senha no seu email!")
            return redirect(url_for("missing_controller.index", page=0))

        if result.status_code == 404:
            abort(404)

    except Exception as e:
        logger.error("Error during create homeless", e)
        abort(500)


@user_controller.route('/edit/<_id>', methods=['GET'])
def edit(_id):
    try:
        if 'user' in session and session['user']['_id'] == _id:
            user = user_service.find_by_id(_id)
            if user.status_code == 200:
                return render_template("user/edit.html", user=user.json()["user"])

            abort(user.status_code)

        abort(403)

    except Exception as e:
        logger.error("Error during create homeless", e)
        abort(500)


@user_controller.route('/update/<_id>', methods=['POST'])
def update(_id):
    try:
        if 'user' in session and session['user']['_id'] == _id:
            parse = user_parse.user_json(request)

            result = user_service.update_user(_id, parse)

            if result.status_code == 200:
                flash("Suas informações foram atualizadas com sucesso!")
                return render_template("user/edit.html", user=result.json()["user"], _id=_id)

            abort(result.status_code)

        abort(403)
    except Exception as e:
        logger.error("Error during create homeless", e)
        abort(500)

templates/user/create.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-info">
                    <h4 class="card-title"><b>Usuário do sistema</b></h4>
                    <p class="card-category"><b>Cadastro necessário para informar o desaparecimento de um familiar.</b></p>
                    <p class="card-title"><b>Todos os campos que possuem (*) são requeridos para o cadastro</b></p>
                </div>
                <div class="card-body">
                    <form action="{{ url_for('user_controller.create_user') }}" method="post"
                          enctype="multipart/form-data">
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="btn btn-info">
                                        <label for="input-file" class="button" style="color: white">
                                            <i class="material-icons">camera_alt</i>
                                            Sua Foto
                                        </label>
                                        <input type="file" id="input-file" name="file" value=""/>
                                        <span id='file-name'></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-5">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Nome *</label>
                                    <input type="text" required="required" maxlength="150" name="name"
                                           class="form-control">
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Email *</label>
                                    <input type="email" required="required" maxlength="150" name="email"
                                           class="form-control">
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Senha *</label>
                                    <input type="password" minlength="6" maxlength="10" required="required" name="password"
                                           class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Telefone fixo</label>
                                    <input type="text" data-mask="(00)0000-0000"
                                           data-mask-selectonfocus="true" name="phone" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Celular</label>
                                    <input type="text" data-mask="(00)00000-0000"
                                           data-mask-selectonfocus="true" name="cell_phone" class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Termos de uso</label>
                                    <input type="checkbox" required="required" name="accept_terms" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <a target="_blank" href="{{ url_for('commons_controller.terms') }}">Politica de privacidade</a>
                                </div>
                            </div>
                        </div>
                        <button type="submit" class="btn btn-info pull-right">Enviar</button>
                        <div class="clearfix"></div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            var $input = document.getElementById('input-file'),
                $fileName = document.getElementById('file-name');

            $input.addEventListener('change', function () {
                $fileName.textContent = this.value + ' tamanho ' + this.files[0].size / 1024 / 1024 + "MB";

            });
        });
    </script>
{% endblock %}

templates/user/edit.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-info">
                    <h4 class="card-title"><b>Alterar meus dados</b></h4>
                    <p class="card-title"><b>Todos os campos que possuem (*) são requeridos para o cadastro</b></p>
                </div>
                <div class="card-body">
                    <form action="{{ url_for('user_controller.update', _id=user._id) }}" method="post"
                          enctype="multipart/form-data">
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="btn btn-info">
                                        <label for="input-file" class="button" style="color: white">
                                            <i class="material-icons">camera_alt</i>
                                            Sua Foto
                                        </label>
                                        <input type="file" id="input-file" name="file" value=""/>
                                        <input type="hidden" name="_id" value="{{ user._id }}"/>
                                        <input type="hidden" name="avatar" value="{{ user.avatar }}"/>
                                        <span id='file-name'></span>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-12">
                                <div class="card-avatar" style="text-align: center">
                                    <img class="img responsive-img avatar"
                                         src="{{ user.avatar if user.avatar else url_for('static', filename="images/image_not_found.png") }}">
                                    <p class="card-title">Sua imagem atual</p>
                                </div>
                            </div>
                        </div>
                        <div class="row" style="margin-top: 20px">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Nome *</label>
                                    <input type="text" required="required" name="name" value="{{ user.name }}"
                                           class="form-control">
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Email *</label>
                                    <input type="email" required="required" name="email" value="{{ user.email }}"
                                           class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Telefone fixo</label>
                                    <input type="text" name="phone" value="{{ user.phone }}" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Celular</label>
                                    <input type="text" value="{{ user.cell_phone }}" name="cell_phone"
                                           class="form-control">
                                </div>
                            </div>
                        </div>
                        <button type="submit" class="btn btn-info pull-right">Alterar</button>
                        <div class="clearfix"></div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script>
        var $input = document.getElementById('input-file'),
            $fileName = document.getElementById('file-name');

        $input.addEventListener('change', function () {
            $fileName.textContent = this.value;
        });

        $('.date').blur(function () {
            if (this.value.trim() != '') {
                let val = this.value.split('/');
                let date = new Date(val[2], val[1], val[0]);
                let today = new Date();
                if (date > today) {
                    demo.showNotification('top', 'right', 'A data que foi informada está acima da data de hoje', 2);
                    this.value = "";
                }
            }
        });
    </script>
{% endblock %}

templates/user/faq.html
{% extends "base.html" %}
{% block content %}
<div class="row">
    <div class="col-md-12">
        <div id="accordion">
            <div class="card">
                <div class="card-header" id="headingOne">
                    <h5 class="mb-0">
                        <button class="btn btn-link faq" data-toggle="collapse" data-target="#collapseOne"
                                aria-expanded="true"
                                aria-controls="collapseOne">
                            Como mantemos a plataforma ?
                        </button>
                    </h5>
                </div>

                <div id="collapseOne" class="collapse show" aria-labelledby="headingOne" data-parent="#accordion">
                    <div class="card-body">
                        Todos os custos pelo sistema, se dão a partir de iniciativa própria, pretendemos
                        fazer parceiras no futuro, para minimizar nossos custos operacionais, porém não queremos manter
                        nossa plataforma poluída com inúmeros banners, afinal de contas queremos que nossos usuários
                        através dos seus celulares tenham a melhor experiência possível.
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingTwo">
                    <h5 class="mb-0">
                        <button class="btn btn-link collapsed faq" data-toggle="collapse" data-target="#collapseTwo"
                                aria-expanded="false" aria-controls="collapseTwo">
                            Política de privacidade
                        </button>
                    </h5>
                </div>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordion">
                    <div class="card-body">
                        As informações dos desaparecidos ficam visíveis para todas as pessoas que utilizam o sistema,
                        mas somente características físicas dos desaparecidos nenhuma informação de caráter pessoal será
                        exposta de forma indevida. Não disponibilizamos para nenhum outro sistema as informações dos
                        nossos usuários, somente se o mesmo autorizar.
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingThree">
                    <h5 class="mb-0">
                        <button class="btn btn-link collapsed faq" data-toggle="collapse" data-target="#collapseThree"
                                aria-expanded="false" aria-controls="collapseThree">
                            Preciso me cadastrar como usuário ?
                        </button>
                    </h5>
                </div>
                <div id="collapseThree" class="collapse" aria-labelledby="headingThree" data-parent="#accordion">
                    <div class="card-body">
                        Você não precisa se cadastrar no sistema para verificar os usuário desaparecidos, ou o mapa de
                        desaparecimento, caso você faça parte de alguma organização envolvida em trabalhos sociais de
                        campo, você pode utilizar a funcionalidade de <b>Quero ser encontrado</b>, onde é feito um
                        cadastro rápido com a imagem nome e o endereço onde a pessoa se encontra e nos submeter, após
                        recebermos a suas informações iremos verificar através de reconhecimento fácil se já existe a
                        busca pelo desaparecido no sistema, caso de match mandaremos uma mensagem para o responsável
                        pelo cadastro.
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingFour">
                    <h5 class="mb-0">
                        <button class="btn btn-link collapsed faq" data-toggle="collapse" data-target="#collapseFour"
                                aria-expanded="false" aria-controls="collapseFour">
                            O que é desaparecimento multicausal ?
                        </button>
                    </h5>
                </div>
                <div id="collapseFour" class="collapse" aria-labelledby="headingFour" data-parent="#accordion">
                    <div class="card-body">
                        <ul>
                            <li>Voluntário – quando a pessoa se afasta por vontade própria e sem avisar, o que pode
                                acontecer por diversos motivos: desentendimento, medo, aflição, choque de visões, planos
                                de vida diferentes.
                            </li>
                            <li>Involuntário – quando a pessoa é afastada do cotidiano por um evento sobre o qual não
                                tem controle, como um acidente, um problema de saúde, um desastre natural.
                            </li>
                            <li>Forçado – quando outras pessoas provocam o afastamento, sem a concordância da pessoa.
                                Como um sequestro ou a ação do próprio estado.
                            </li>
                        </ul>
                    </div>
                </div>
            </div>

            <div class="card">
                <div class="card-header" id="headingFive">
                    <h5 class="mb-0">
                        <button class="btn btn-link collapsed faq" data-toggle="collapse" data-target="#collapseFive"
                                aria-expanded="false" aria-controls="collapseFive" style="font-size: 11px">
                            Sobre as pessoas que querem ser encontradas
                        </button>
                    </h5>
                </div>
                <div id="collapseFive" class="collapse" aria-labelledby="headingFive" data-parent="#accordion">
                    <div class="card-body">
                        <div class="card-body">
                            Atualmente no Brasil temos aproximadamente 101 Mil moradores de ruas, muitos deles possuem
                            familia e a mesma não sabem mais sobre sua localização. São para essas pessoas que querem ser
                            encontradas por seus familiares que a plataforma servirá também.
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

templates/user/login.html
{% extends "base.html" %}
{% block content %}

<div class="row">
    <dib class="col-md-12">
        <div class="card" id="loginModal" tabindex="-1" role="">
            <form class="form" method="POST" action="{{ url_for('user_controller.authentication') }}">
                <div class="card-header card-header-info">
                    <div class="text-center">
                        <img src="{{ url_for('static', filename='images/logo.png') }}"/>
                        <h3 style="color: white; font-weight: bold" class="description text-center">Acessar
                            o
                            sistema</h3>
                        <p style="margin-top: 5px; font-weight: bold">Acesse as suas
                            notificações.</p>
                    </div>
                </div>
                <div class="card-body">
                    <div class="card-group">
                        <div class="form-group col-md-12">
                            <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="material-icons">email</i>
                                    </span>
                                <input type="text" name="email" class="form-control" placeholder="Email...">
                            </div>
                        </div>

                        <div class="form-group col-md-12">
                            <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="material-icons">lock_outline</i>
                                    </span>
                                <input type="password" name="password" placeholder="Password..."
                                       class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-footer justify-content-center">
                    <a class="btn btn-link" href="{{ url_for("user_controller.remember_me") }}">
                        Recuperar Senha
                    </a>
                    <button type="submit" id="entrar" class="btn btn-success">
                        Entrar
                    </button>
                </div>
            </form>
        </div>
    </dib>
</div>


{% endblock %}

templates/user/notifications.html
{% extends "base.html" %}
{% block content %}
<div class="row">
    <div class="col-md-12">
        <div id="map" style='width: 100%; max-height: 500px'></div>
    </div>
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            const features = []
            const center = [-47.9100981, -15.85144512]
            const accessToken = 'pk.eyJ1IjoiZGVzYXBhcmVjaWRvc21lIiwiYSI6ImNqa3ZrYWdqcDBzMzUzcHBhdGhhdWp1YmEifQ.09Yj5rE71q2u_WGfPu3LFA'

            $.getJSON("{{ url_for('user_controller.notifications_list', _id=_id) }}", function (data) {
                $.each(data.locations, function (key, val) {
                    features.push({
                        "type": "Feature",
                        "properties": {
                            "description": `Data da notificação ${val.registration_date}, Observação ${val.observation}`,
                        },
                        "geometry": {
                            "type": "Point",
                            "coordinates": val.geometry
                        }
                    })
                });

                let geojson = {
                    type: 'FeatureCollection',
                    features: features
                };

                setupMapBox(accessToken, center, "map" , geojson, 3);
            });

        });
    </script>
</div>
{% endblock %}

templates/user/password.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <dib class="col-md-12">
            <div class="card" tabindex="-1" role="">
                <form class="form" id="change-password" method="POST"
                      action="{{ url_for('user_controller.change_password', _id=_id) }}">
                    <div class="card-header card-header-info">
                        <div class="text-center">
                            <h3 style="color: white; font-weight: bold" class="description text-center">Alterar sua
                                senha</h3>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="card-group">
                            <div class="form-group col-md-12">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="material-icons">lock_outline</i>
                                    </span>
                                    <input type="password" minlength="6" maxlength="10" name="password" id="password"
                                           class="form-control"
                                           placeholder="Nova senha...">
                                </div>
                            </div>

                            <div class="form-group col-md-12">
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="material-icons">lock_outline</i>
                                    </span>
                                    <input type="password" minlength="6" maxlength="10" id="new_password"
                                           name="confirm_password"
                                           placeholder="Confirmar senha ..."
                                           class="form-control">
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-footer justify-content-center">
                        <button type="button" id="send" class="btn btn-success">
                            Alterar
                        </button>
                    </div>
                </form>
            </div>
        </dib>
    </div>
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            $('#send').click(function () {
                let password = $('#password').val();
                let new_password = $('#new_password').val();
                if (password !== new_password) {
                    demo.showNotification('top', 'right', 'As senhas informadas não conferem!', 2);
                    this.value = "";
                    return;
                }
                $('#change-password').submit();
            });
        });
    </script>
{% endblock %}